﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Paginate
{
    public partial class Paginate : System.Web.UI.Page
    {
        public int currentpageindex = 0;//当前页数
        public int pagesize = 16;//每页显示的条数

        public int pagecount = 0;//页数
        public int rowscount = 320;//总条数
        public string prevtext = "前一页";
        public string nexttext = "后一页";
        public string ellipsetext = "...";//分隔符
        public int edgeentries = 2;//页边
        public bool prevshowalways = true;//前一页按钮是否显示
        public bool nextshowalways = true;//后一页按钮是否显示
        public int displayentries = 6;//显示几个按钮
        public string url;
        public string pagestr = "";
        protected void Page_Load(object sender, EventArgs e)
        {
            currentpageindex = Request.QueryString["pageid"] == null ? 1 : Convert.ToInt32(Request.QueryString["pageid"].ToString());
            DrawLink();
        }
        //计算最大的页数
        public int NumPages()
        {
            return Convert.ToInt32(Math.Ceiling((decimal)rowscount / pagesize));
        }
        //根据当前页数和显示数目计算开始和结束的分页按钮
        public int[] GetInterval()
        {
            int nehalf = Convert.ToInt32(Math.Ceiling((decimal)displayentries / 2));
            pagecount = NumPages();
            int upperlimit = pagecount - displayentries+1;
            int start,end;
            if (displayentries % 2 == 0)
            {
               start = currentpageindex > nehalf ? Math.Max(Math.Min(currentpageindex - nehalf, upperlimit), 1) : 1;
            }
            else 
            {
                start = currentpageindex > nehalf ? Math.Max(Math.Min(currentpageindex - nehalf+1, upperlimit), 1) : 1;
            }
            end = currentpageindex > nehalf ? Math.Min(currentpageindex + nehalf - 1, pagecount) : Math.Min(displayentries, pagecount);
            return new int[] { start, end };
        }

        public string DrawLink()
        {
            //首先得到开始和结束的数组
            int[] interval = GetInterval();


            //生成前一页链接
            if (prevtext != "" && currentpageindex > 1 && prevshowalways)
            {
                pagestr = AppendItem(currentpageindex - 1, prevtext);
            }
            //看是否有边界页，是否需要分界符
            if (interval[0] > 1 && edgeentries > 0)
            {
                //检查边界和开始谁小，画按钮
                int end = Math.Min(edgeentries, interval[0]);
                //生成边界页
                if (edgeentries == interval[0]) //注意interval[0]和edgeentries相等的时候，会出现重复
                {
                    for (int i = 1; i < end; i++)
                    {
                        pagestr = pagestr + AppendItem(i, i.ToString());
                    }
                }
                else
                {
                    for (int i = 1; i <= end; i++)//从1开始，因此i要小于等于end，这样才会把end这个按钮画上
                    {
                        pagestr = pagestr + AppendItem(i, i.ToString());
                    }
                }
                //生成分界符
                if (edgeentries + 1 < interval[0] && ellipsetext != "")
                {
                    pagestr = pagestr + "<span>" + ellipsetext + "</span>";
                }
            }


            for (int i = interval[0]; i <= interval[1]; i++)
            {
                pagestr = pagestr + AppendItem(i, i.ToString());
            }

            if (interval[1] < pagecount && edgeentries > 0)//结尾
            {
                if (pagecount - edgeentries > interval[1] && ellipsetext != "")
                {
                    pagestr = pagestr + "<span>" + ellipsetext + "</span>";
                }
                int begin = Math.Max(pagecount - edgeentries + 1, interval[1]);
                if (pagecount - edgeentries + 1 == interval[1])
                {
                    for (int i = begin+1; i <= pagecount; i++)
                    {
                        pagestr = pagestr + AppendItem(i, i.ToString());
                    }
                }
                else 
                {
                    for (int i = begin; i <= pagecount; i++)
                    {
                        pagestr = pagestr + AppendItem(i, i.ToString());
                    }
                }

            }
            //生成后一页链接
            if (nexttext != "" && currentpageindex < pagecount && nextshowalways)
            {
                pagestr = pagestr + AppendItem(currentpageindex + 1, nexttext);
            }
            return pagestr;
        }
        public string AppendItem(int pageid, string text)
        {
            string lnk;
            int id = pageid < 1 ? 1 : (pageid < pagecount ? pageid : pagecount);
            if (id == currentpageindex)
            {
                lnk = "<span class='current'>" + text + "</span>";
            }
            else
            {
                lnk = "<a href=?" + url + "&pageid=" + id + ">" + text + "</a>";
            }
            return lnk;
        }
    }
}